/**
 * @file Checkboxes
 * @description 多选输入框
 * @author fex
 */
import React from 'react';
import { ClassNamesFn, ThemeProps } from '../theme';
import { Option, Options } from './Select';
export interface CheckboxesProps extends ThemeProps {
    options: Options;
    className?: string;
    placeholder?: string;
    value?: Array<any>;
    onChange?: (value: Array<Option>) => void;
    inline?: boolean;
    labelClassName?: string;
    option2value?: (option: Option) => any;
    itemClassName?: string;
    itemRender: (option: Option) => JSX.Element;
    disabled?: boolean;
}
export declare class Checkboxes<T extends CheckboxesProps = CheckboxesProps, S = any> extends React.Component<T, S> {
    static defaultProps: {
        placeholder: string;
        itemRender: (option: Option) => JSX.Element;
    };
    static value2array(value: any, options: Options, option2value?: (option: Option) => any): Options;
    toggleOption(option: Option): void;
    toggleAll(): void;
    render(): JSX.Element;
}
declare const _default: React.ComponentClass<Pick<Pick<CheckboxesProps, "disabled" | "inline" | "value" | "options" | "className" | "classPrefix" | "classnames" | "onChange" | "labelClassName" | "option2value" | "itemClassName"> & Partial<Pick<CheckboxesProps, "placeholder" | "itemRender">> & Partial<Pick<{
    placeholder: string;
    itemRender: (option: Option) => JSX.Element;
}, never>>, "disabled" | "inline" | "value" | "options" | "className" | "placeholder" | "onChange" | "labelClassName" | "option2value" | "itemClassName" | "itemRender"> & {
    theme?: string | undefined;
    classPrefix?: string | undefined;
    classnames?: ClassNamesFn | undefined;
}, any> & {
    ComposedComponent: typeof Checkboxes;
};
export default _default;
