import { Checkboxes, CheckboxesProps } from './Checkboxes';
import React from 'react';
import { Option } from './Select';
export interface TableCheckboxesProps extends CheckboxesProps {
    columns: Array<{
        name: string;
        label: string;
        [propName: string]: any;
    }>;
    cellRender: (column: {
        name: string;
        label: string;
        [propName: string]: any;
    }, option: Option) => JSX.Element;
}
export declare class TableCheckboxes extends Checkboxes<TableCheckboxesProps> {
    static defaultProps: {
        cellRender: (column: {
            [propName: string]: any;
            name: string;
            label: string;
        }, option: Option) => JSX.Element;
        placeholder: string;
        itemRender: (option: Option) => JSX.Element;
    };
    getColumns(): {
        [propName: string]: any;
        name: string;
        label: string;
    }[];
    renderTHead(): JSX.Element;
    renderTBody(): JSX.Element;
    render(): JSX.Element;
}
declare const _default: React.ComponentClass<Pick<Pick<TableCheckboxesProps, "disabled" | "inline" | "value" | "options" | "className" | "columns" | "classPrefix" | "classnames" | "onChange" | "labelClassName" | "option2value" | "itemClassName"> & Partial<Pick<TableCheckboxesProps, "placeholder" | "itemRender" | "cellRender">> & Partial<Pick<{
    cellRender: (column: {
        [propName: string]: any;
        name: string;
        label: string;
    }, option: Option) => JSX.Element;
    placeholder: string;
    itemRender: (option: Option) => JSX.Element;
}, never>>, "disabled" | "inline" | "value" | "options" | "className" | "columns" | "placeholder" | "onChange" | "labelClassName" | "option2value" | "itemClassName" | "itemRender" | "cellRender"> & {
    theme?: string | undefined;
    classPrefix?: string | undefined;
    classnames?: import("../theme").ClassNamesFn | undefined;
}, any> & {
    ComposedComponent: typeof TableCheckboxes;
};
export default _default;
